/* Kansai basic seminar 2014.3.1 ver.3 */

int red = 73; // one-third of maximum brightness 220
int green = 77; // one-third of maximum brightness 230
int blue = 43; // one-third of maximum brightness 130

int sw_white, sw_red, sw_green, sw_blue; // switch status (ON=1, Off=0)
int light; // light sensor status

int i_white=0; int i_light=0; int i_red=0; int i_green=0; int i_blue=0;

void setup() {                
  // analog pin
  // a5  input
  // digital pin input and output setting
  pinMode(4, INPUT);   // yellow switch
  pinMode(7, INPUT);   // red switch
  pinMode(8, INPUT);   // green switch
  pinMode(9, INPUT);   // blue switch
  pinMode(2, OUTPUT);  // white LED
  pinMode(3, OUTPUT);  // red LED
  pinMode(5, OUTPUT);  // green LED
  pinMode(6, OUTPUT);  // blue LED
  pinMode(14, OUTPUT); // LED bar red 1
  pinMode(15, OUTPUT); // LED bar red 2
  pinMode(16, OUTPUT); // LED bar red 3
  pinMode(17, OUTPUT); // LED bar green 1
  pinMode(18, OUTPUT); // LED bar green 2
  pinMode(10, OUTPUT); // LED bar green 3
  pinMode(11, OUTPUT); // LED bar blue 1
  pinMode(12, OUTPUT); // LED bar blue 2
  pinMode(13, OUTPUT); // LED bar blue 3
}

void loop() {
  checkAll();
  sw_white=digitalRead(4);
  if(sw_white==1){demo();}
  sw_red=digitalRead(7);
  if(sw_red==1){demo2();}
  sw_green=digitalRead(8);
  if(sw_green==1){demo3();}  
  sw_blue=digitalRead(9);
  if(sw_blue==1){demo4();}  
  while(1){
   light=analogRead(5); // check analog input A5 voltage 
   if(light < 500){i_light=1;} else{i_light=0;}
   sw_white=digitalRead(4);
   if(sw_white==1){delay(200);i_white=i_white+1;if(i_white>2){i_white=0;}}      
   sw_red=digitalRead(7);
   if(sw_red==1){delay(200);i_red=i_red+1;if(i_red>3){i_red=0;}}
   sw_green=digitalRead(8);
   if(sw_green==1){delay(200);i_green=i_green+1;if(i_green>3){i_green=0;}}
   sw_blue=digitalRead(9);  
   if(sw_blue==1){delay(200);i_blue=i_blue+1;if(i_blue>3){i_blue=0;}}
   barLED();
   if(i_white==0 && i_light==1) {digitalWrite(2, HIGH);}
   if(i_white==0 && i_light==0) {digitalWrite(2, LOW);}
   if(i_white==1) {digitalWrite(2, HIGH);}
   if(i_white==2) {digitalWrite(2, LOW);}   
   analogWrite(3, red*i_red);
   analogWrite(5, green*i_green);
   analogWrite(6, blue*i_blue);   
  } // end-of-while
} // end-of-loop

void barLED() {
  if(i_red==0){digitalWrite(14,LOW);digitalWrite(15,LOW);digitalWrite(16,LOW);}
  if(i_red==1){digitalWrite(14,HIGH);digitalWrite(15,LOW);digitalWrite(16,LOW);}
  if(i_red==2){digitalWrite(14,HIGH);digitalWrite(15,HIGH);digitalWrite(16,LOW);}
  if(i_red==3){digitalWrite(14,HIGH);digitalWrite(15,HIGH);digitalWrite(16,HIGH);}
  if(i_green==0){digitalWrite(17,LOW);digitalWrite(18,LOW);digitalWrite(10,LOW);}
  if(i_green==1){digitalWrite(17,HIGH);digitalWrite(18,LOW);digitalWrite(10,LOW);}
  if(i_green==2){digitalWrite(17,HIGH);digitalWrite(18,HIGH);digitalWrite(10,LOW);}
  if(i_green==3){digitalWrite(17,HIGH);digitalWrite(18,HIGH);digitalWrite(10,HIGH);}
  if(i_blue==0){digitalWrite(11,LOW);digitalWrite(12,LOW);digitalWrite(13,LOW);}
  if(i_blue==1){digitalWrite(11,HIGH);digitalWrite(12,LOW);digitalWrite(13,LOW);}
  if(i_blue==2){digitalWrite(11,HIGH);digitalWrite(12,HIGH);digitalWrite(13,LOW);}
  if(i_blue==3){digitalWrite(11,HIGH);digitalWrite(12,HIGH);digitalWrite(13,HIGH);}
}

// light on all LED a second for check 
void checkAll() {
  digitalWrite(2, HIGH); // white LED
  analogWrite(3, red);  // red LED
  analogWrite(5, green);  // green LED
  analogWrite(6, blue);  // blue LED
  digitalWrite(14, HIGH); // LED bar red 1
  digitalWrite(15, HIGH); // LED bar red 2
  digitalWrite(16, HIGH); // LED bar red 3
  digitalWrite(17, HIGH); // LED bar green 1
  digitalWrite(18, HIGH); // LED bar green 2
  digitalWrite(10, HIGH); // LED bar green 3
  digitalWrite(11, HIGH); // LED bar blue 1
  digitalWrite(12, HIGH); // LED bar blue 2
  digitalWrite(13, HIGH); // LED bar blue 3
  delay(1000); // wait 1000 msec
  digitalWrite(2, LOW); // white LED
  analogWrite(3, 0);  // red LED
  analogWrite(5, 0);  // green LED
  analogWrite(6, 0);  // blue LED
  digitalWrite(14, LOW); // LED bar red 1
  digitalWrite(15, LOW); // LED bar red 2
  digitalWrite(16, LOW); // LED bar red 3
  digitalWrite(17, LOW); // LED bar green 1
  digitalWrite(18, LOW); // LED bar green 2
  digitalWrite(10, LOW); // LED bar green 3
  digitalWrite(11, LOW); // LED bar blue 1
  digitalWrite(12, LOW); // LED bar blue 2
  digitalWrite(13, LOW); // LED bar blue 3  
}

void demo() {
  while(1) {
    digitalWrite(2, LOW); // white LED
    i_red=3;i_green=0;i_blue=0; 
    analogWrite(3, red*i_red);
    analogWrite(5, green*i_green);
    analogWrite(6, blue*i_blue);     
    delay(1000);
    i_red=2;i_green=2;i_blue=0; 
    analogWrite(3, red*i_red);
    analogWrite(5, green*i_green);
    analogWrite(6, blue*i_blue);      
    delay(1000);
    i_red=0;i_green=3;i_blue=0; 
    analogWrite(3, red*i_red);
    analogWrite(5, green*i_green);
    analogWrite(6, blue*i_blue);     
    delay(1000);    
    i_red=0;i_green=2;i_blue=2; 
    analogWrite(3, red*i_red);
    analogWrite(5, green*i_green);
    analogWrite(6, blue*i_blue);      
    delay(1000);
    i_red=0;i_green=0;i_blue=3; 
    analogWrite(3, red*i_red);
    analogWrite(5, green*i_green);
    analogWrite(6, blue*i_blue);     
    delay(1000);
    i_red=2;i_green=0;i_blue=2; 
    analogWrite(3, red*i_red);
    analogWrite(5, green*i_green);
    analogWrite(6, blue*i_blue);    
    delay(1000); 
  } // end-of-while
} // end-of-demo  

void demo2() {
  while(1) {
    int waitTime=100;
    digitalWrite(2, HIGH); // white LED
    delay(waitTime/10);
    digitalWrite(2, LOW); // white LED
    digitalWrite(14, HIGH); // LED bar red 1
    delay(waitTime);
    digitalWrite(14, LOW); // LED bar red 1
    digitalWrite(15, HIGH); // LED bar red 2
    delay(waitTime);
    digitalWrite(15, LOW); // LED bar red 2
    digitalWrite(16, HIGH); // LED bar red 3
    delay(waitTime);
    digitalWrite(16, LOW); // LED bar red 3
    digitalWrite(17, HIGH); // LED bar green 1
    delay(waitTime);
    digitalWrite(17, LOW); // LED bar green 1
    digitalWrite(18, HIGH); // LED bar green 2
    delay(waitTime);
    digitalWrite(18, LOW); // LED bar green 2
    digitalWrite(10, HIGH); // LED bar green 3
    delay(waitTime);
    digitalWrite(10, LOW); // LED bar green 3
    digitalWrite(11, HIGH); // LED bar blue 1
    delay(waitTime);
    digitalWrite(11, LOW);  // LED bar blue 1
    digitalWrite(12, HIGH); // LED bar blue 2
    delay(waitTime);
    digitalWrite(12, LOW); // LED bar blue 2
    digitalWrite(13, HIGH); // LED bar blue 3
    delay(waitTime);
    digitalWrite(13, LOW); // LED bar blue 3
    analogWrite(3, red*2); // red LED
    delay(waitTime);
    analogWrite(3, 0); // red LED
    analogWrite(5, green*2); // green LED
    delay(waitTime);
    analogWrite(5, 0); // blue LED
    analogWrite(6, blue*2); // green LED
    delay(waitTime);
    analogWrite(6, 0); // blue LED
    analogWrite(5, green*2); // green LED
    delay(waitTime);
    analogWrite(5, 0); // blue LED
    analogWrite(3, red*2); // red LED
    delay(waitTime);
    analogWrite(3, 0); // red LED
    digitalWrite(13, HIGH); // LED bar blue 3
    delay(waitTime);
    digitalWrite(13, LOW); // LED bar blue 3
    digitalWrite(12, HIGH); // LED bar blue 2
    delay(waitTime);
    digitalWrite(12, LOW); // LED bar blue 2
    digitalWrite(11, HIGH); // LED bar blue 1
    delay(waitTime);
    digitalWrite(11, LOW);  // LED bar blue 1
    digitalWrite(10, HIGH); // LED bar green 3
    delay(waitTime);
    digitalWrite(10, LOW); // LED bar green 3
    digitalWrite(18, HIGH); // LED bar green 2
    delay(waitTime);
    digitalWrite(18, LOW); // LED bar green 2
    digitalWrite(17, HIGH); // LED bar green 1
    delay(waitTime);
    digitalWrite(17, LOW); // LED bar green 1
    digitalWrite(16, HIGH); // LED bar red 3
    delay(waitTime);
    digitalWrite(16, LOW); // LED bar red 3
    digitalWrite(15, HIGH); // LED bar red 2
    delay(waitTime);
    digitalWrite(15, LOW); // LED bar red 2
  } // end-of-while
} // end-of-demo2

void demo3() {
  while(1) {
  i_red=1;i_green=0;i_blue=0;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=2;i_green=0;i_blue=0;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=0;i_blue=0;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=1;i_blue=0;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=2;i_blue=0;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=3;i_blue=0;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=3;i_blue=1;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=3;i_blue=2;
  light=analogRead(5);
  barLED();delay(light*2);
  i_red=3;i_green=3;i_blue=3;
  light=analogRead(5);
  barLED();delay(light*2);
  if(light < 500){break;}
  } //end-of-white
  while(1) {
   i_red=1;i_green=0;i_blue=0;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, i);
     analogWrite(5, 0);
     analogWrite(6, 0);
     delay((1023-light)/32);  
   } 
   i_red=1;i_green=0;i_blue=0;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, 255-i);
     analogWrite(5, 0);
     analogWrite(6, 0);
     delay((1023-light)/32);  
   }
   i_red=0;i_green=1;i_blue=0;barLED();   
   for( int i=0; i<256; i++){
     analogWrite(3, 0);
     analogWrite(5, i);
     analogWrite(6, 0);
     delay((1023-light)/32);  
   }
   i_red=0;i_green=1;i_blue=0;barLED();  
   for( int i=0; i<256; i++){
     analogWrite(3, 0);
     analogWrite(5, 255-i);
     analogWrite(6, 0);
     delay((1023-light)/32);  
   } 
   i_red=0;i_green=0;i_blue=1;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, 0);
     analogWrite(5, 0);
     analogWrite(6, i);
     delay((1023-light)/32);  
   }  
   i_red=0;i_green=0;i_blue=1;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, 0);
     analogWrite(5, 0);
     analogWrite(6, 255-i);
     delay((1023-light)/32);  
   }  
   i_red=1;i_green=1;i_blue=0;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, i);
     analogWrite(5, i);
     analogWrite(6, 0);
     delay((1023-light)/32);  
   }  
   i_red=1;i_green=1;i_blue=0;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, 255-i);
     analogWrite(5, 255-i);
     analogWrite(6, 0);
     delay((1023-light)/32);  
   }  
    i_red=0;i_green=1;i_blue=1;barLED();
    for( int i=0; i<256; i++){
     analogWrite(3, 0);
     analogWrite(5, i);
     analogWrite(6, i);
     delay((1023-light)/32);  
   }    
   i_red=0;i_green=1;i_blue=1;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, 0);
     analogWrite(5, 255-i);
     analogWrite(6, 255-i);
     delay((1023-light)/32);  
   } 
   i_red=1;i_green=0;i_blue=1;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, i);
     analogWrite(5, 0);
     analogWrite(6, i);
     delay((1023-light)/32);  
   }    
   i_red=1;i_green=0;i_blue=1;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, 255-i);
     analogWrite(5, 0);
     analogWrite(6, 255-i);
     delay((1023-light)/32);  
   } 
   i_red=1;i_green=1;i_blue=1;barLED();
   for( int i=0; i<256; i++){
     analogWrite(3, i);
     analogWrite(5, i);
     analogWrite(6, i);
     delay((1023-light)/32);  
   }
   i_red=1;i_green=1;i_blue=1;barLED();   
   for( int i=0; i<256; i++){
     analogWrite(3, 255-i);
     analogWrite(5, 255-i);
     analogWrite(6, 255-i);
     delay((1023-light)/32);  
   } 
  } //end-of-white
} // end-of-demo3

void demo4() {
while(1){
  light=analogRead(5);
  randomSeed(light);
  int waitTime=1000;
  i_red=1;i_green=1;i_blue=1;
  barLED();
  delay(1000);
  i_red=2;i_green=2;i_blue=2;
  barLED();
  delay(1000);
  i_red=3;i_green=3;i_blue=3;
  barLED();
  delay(1000);
  analogWrite(3,red);
  analogWrite(5,green);
  analogWrite(6,blue);
  delay(100);
  analogWrite(3,0);
  analogWrite(5,0);
  analogWrite(6,0);
  delay(100);  
  analogWrite(3,red);
  analogWrite(5,green);
  analogWrite(6,blue);
  delay(100);
  analogWrite(3,0);
  analogWrite(5,0);
  analogWrite(6,0);
  delay(1000);
  while(1) {
    barLED();
    int val=random(0,3);
    if(val==0){
      analogWrite(3,red/2);delay(waitTime);
      sw_red=digitalRead(7);sw_green=digitalRead(8);sw_blue=digitalRead(9);
      if(sw_red==0){i_red=i_red-1;if(i_red<0){i_red=0;}}
      if(sw_green==1){i_green=i_green-1;if(i_green<0){i_green=0;}}
      if(sw_blue==1){i_blue=i_blue-1;if(i_blue<0){i_blue=0;}}
      analogWrite(3,0);
    }
    if(val==1){
      analogWrite(5,green/2);delay(waitTime);
      sw_red=digitalRead(7);sw_green=digitalRead(8);sw_blue=digitalRead(9);
      if(sw_red==1){i_red=i_red-1;if(i_red<0){i_red=0;}}
      if(sw_green==0){i_green=i_green-1;if(i_green<0){i_green=0;}}
      if(sw_blue==1){i_blue=i_blue-1;if(i_blue<0){i_blue=0;}}
      analogWrite(5,0);
    }
    if(val==2){
      analogWrite(6,blue/2);delay(waitTime);
      sw_red=digitalRead(7);sw_green=digitalRead(8);sw_blue=digitalRead(9);
      if(sw_red==1){i_red=i_red-1;if(i_red<0){i_red=0;}}
      if(sw_green==1){i_green=i_green-1;if(i_green<0){i_green=0;}}
      if(sw_blue==0){i_blue=i_blue-1;if(i_blue<0){i_blue=0;}}
      analogWrite(6,0);
    }
    barLED();
    delay(waitTime);
    if(waitTime>500){waitTime=waitTime-3;}
    if(waitTime>400){waitTime=waitTime-2;}
    if(waitTime>300){waitTime=waitTime-1;}
    if(waitTime>200){waitTime=waitTime-1;}
    if(waitTime>150){waitTime=waitTime-1;}
    if(waitTime>100){waitTime=waitTime-1;}
    if(waitTime>50){waitTime=waitTime-1;}
    if(waitTime<10){waitTime=10;}   
    if(i_red+i_green+i_blue==0){
      delay(3000);
      break;
    }    
  } // end-of-while
} // end-of-while
} // end-of-demo4

